#include <stdlib.h>
#ifndef lint
#ifdef __unused
__unused
#endif
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.37 2003/02/12 18:03:55 davidc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#if defined(__cplusplus) || __STDC__
static int yygrowstack(void);
#else
static int yygrowstack();
#endif
#define yyparse time_parseparse
#define yylex time_parselex
#define yyerror time_parseerror
#define yychar time_parsechar
#define yyval time_parseval
#define yylval time_parselval
#define yydebug time_parsedebug
#define yynerrs time_parsenerrs
#define yyerrflag time_parseerrflag
#define yyss time_parsess
#define yyssp time_parsessp
#define yyvs time_parsevs
#define yyvsp time_parsevsp
#define yylhs time_parselhs
#define yylen time_parselen
#define yydefred time_parsedefred
#define yydgoto time_parsedgoto
#define yysindex time_parsesindex
#define yyrindex time_parserindex
#define yygindex time_parsegindex
#define yytable time_parsetable
#define yycheck time_parsecheck
#define yyname time_parsename
#define yyrule time_parserule
#define yysslim time_parsesslim
#define yystacksize time_parsestacksize
#define YYPREFIX "time_parse"
#line 2 "grammar.y"
#include <ipex_includes.h>

#include "time.h"

extern struct datespec *dsp;
static struct tm *tm;
static time_t time1;

#define	PUTRANGE()	printf("range: from %u to %u\n", dsp->lower, dsp->upper)
#define SETTIME(x) do {					\
	if ((tm = malloc(sizeof(struct tm))) == 0)      \
		errx(1, "exhausted memory.");           \
	x = time(NULL);                                 \
	tm = localtime(&x);				\
} while (0)

#line 21 "grammar.y"
typedef union {
	char *string;
} YYSTYPE;
#line 71 "y.tab.c"
#define YYERRCODE 256
#define EQ 257
#define LT 258
#define GT 259
#define LE 260
#define GE 261
#define GL 262
#define DATE 263
#define TIME 264
#define TIMESPEC 265
#define DATESPEC 266
const short time_parselhs[] = {                                        -1,
    0,    0,    0,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    2,    2,    2,    3,    3,    3,    3,    3,
    3,
};
const short time_parselen[] = {                                         2,
    1,    1,    1,    3,    3,    3,    3,    3,    4,    3,
    3,    3,    3,    3,    4,    5,    5,    5,    5,    5,
    7,
};
const short time_parsedefred[] = {                                      0,
    0,    0,    0,    1,    2,    3,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
   12,   11,   14,   13,    0,    0,    0,    0,    0,    0,
    0,    4,    6,    5,    8,    7,    0,    0,    0,    0,
    0,    0,    0,   15,    9,   16,   18,   17,   20,   19,
    0,    0,   21,
};
const short time_parsedgoto[] = {                                       3,
    4,    5,    6,
};
const short time_parsesindex[] = {                                   -258,
 -257, -237,    0,    0,    0,    0, -251, -250, -249, -248,
 -241, -247, -254, -239, -238, -236, -235, -234, -230,    0,
    0,    0,    0,    0, -233, -232, -231, -229, -228, -226,
 -225,    0,    0,    0,    0,    0, -223, -222, -221, -220,
 -219, -218, -214,    0,    0,    0,    0,    0,    0,    0,
 -217, -215,    0,
};
const short time_parserindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
const short time_parsegindex[] = {                                      0,
    0,    0,    0,
};
#define YYTABLESIZE 50
const short time_parsetable[] = {                                       7,
    8,    9,   10,   11,    1,    2,   12,   31,   13,   25,
   26,   27,   28,   29,   20,   21,   22,   23,   30,   14,
   15,   16,   17,   18,   24,   32,   33,   19,   34,   35,
   36,   37,   38,   39,   40,    0,   41,   42,   43,    0,
   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
};
const short time_parsecheck[] = {                                     257,
  258,  259,  260,  261,  263,  264,  264,  262,  266,  257,
  258,  259,  260,  261,  266,  266,  266,  266,  266,  257,
  258,  259,  260,  261,  266,  265,  265,  265,  265,  265,
  265,  262,  266,  266,  266,   -1,  266,  266,  265,   -1,
  266,  265,  265,  265,  265,  265,  265,  262,  266,  265,
};
#define YYFINAL 3
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 266
#if YYDEBUG
const char * const time_parsename[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"EQ","LT","GT","LE","GE","GL",
"DATE","TIME","TIMESPEC","DATESPEC",
};
const char * const time_parserule[] = {
"$accept : ENTRY",
"ENTRY : timecmp",
"ENTRY : datecmp",
"ENTRY : combocmp",
"timecmp : TIME EQ TIMESPEC",
"timecmp : TIME GT TIMESPEC",
"timecmp : TIME LT TIMESPEC",
"timecmp : TIME GE TIMESPEC",
"timecmp : TIME LE TIMESPEC",
"timecmp : TIME TIMESPEC GL TIMESPEC",
"datecmp : DATE EQ DATESPEC",
"datecmp : DATE GT DATESPEC",
"datecmp : DATE LT DATESPEC",
"datecmp : DATE GE DATESPEC",
"datecmp : DATE LE DATESPEC",
"datecmp : DATE DATESPEC GL DATESPEC",
"combocmp : DATE TIME EQ DATESPEC TIMESPEC",
"combocmp : DATE TIME GT DATESPEC TIMESPEC",
"combocmp : DATE TIME LT DATESPEC TIMESPEC",
"combocmp : DATE TIME GE DATESPEC TIMESPEC",
"combocmp : DATE TIME LE DATESPEC TIMESPEC",
"combocmp : DATE TIME DATESPEC TIMESPEC GL DATESPEC TIMESPEC",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 30 "grammar.y"
{
		;
	}
break;
case 2:
#line 34 "grammar.y"
{
		;
	}
break;
case 3:
#line 38 "grammar.y"
{
		;
	}
break;
case 4:
#line 45 "grammar.y"
{
		SETTIME(time1);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1;
		dsp->lower = time1;
	}
break;
case 5:
#line 53 "grammar.y"
{
		SETTIME(time1);
		time1 = time(NULL);
		tm = localtime(&time1);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1 + 1;
	}
break;
case 6:
#line 63 "grammar.y"
{
		SETTIME(time1);
		time1 = time(NULL);
		tm = localtime(&time1);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1 - 1;
		dsp->lower = 0;
	}
break;
case 7:
#line 73 "grammar.y"
{
		SETTIME(time1);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1;
	}
break;
case 8:
#line 81 "grammar.y"
{
		SETTIME(time1);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1;
		dsp->lower = 0;
	}
break;
case 9:
#line 89 "grammar.y"
{
		if ((tm = malloc(sizeof(struct tm))) == 0)
			errx(1, "exhausted memory.");
		time1 = time(NULL);
		tm = localtime(&time1);
		strptime(yyvsp[-2].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->lower = time1;
		time1 = time(NULL);
		strptime(yyvsp[0].string, "%H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1;
	}
break;
case 10:
#line 106 "grammar.y"
{
		SETTIME(time1);
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->lower = time1;
		dsp->upper = time1 + (86400 - 1);
	}
break;
case 11:
#line 115 "grammar.y"
{
		SETTIME(time1);
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1 + 86400;
	}
break;
case 12:
#line 124 "grammar.y"
{
		SETTIME(time1);
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->upper = time1 - 1;
		dsp->lower = 0;
	}
break;
case 13:
#line 133 "grammar.y"
{
		SETTIME(time1);
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1;
	}
break;
case 14:
#line 142 "grammar.y"
{
		SETTIME(time1);
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->upper = time1 + (86400 - 1);
		dsp->lower = 0;
	}
break;
case 15:
#line 151 "grammar.y"
{
		if ((tm = malloc(sizeof(struct tm))) == 0)
			errx(1, "exhausted memory");
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[-2].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->lower = time1 + 86400;
		memset(tm, 0, sizeof(*tm));
		strptime(yyvsp[0].string, "%Y-%m-%d", tm);
		time1 = mktime(tm);
		dsp->upper = time1 - 1;
	}
break;
case 16:
#line 166 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		SETTIME(time1);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = dsp->lower = time1;
	}
break;
case 17:
#line 176 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		SETTIME(time1);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1 + 1;
	}
break;
case 18:
#line 187 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		SETTIME(time1);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1 - 1;
		dsp->lower = 0;
	}
break;
case 19:
#line 198 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		SETTIME(time1);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = UINT_MAX;
		dsp->lower = time1;
	}
break;
case 20:
#line 209 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		SETTIME(time1);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1;
		dsp->lower = 0;
	}
break;
case 21:
#line 220 "grammar.y"
{
		char tmbuf[20];

		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-4].string, yyvsp[-3].string);
		if ((tm = malloc(sizeof(struct tm))) == 0)
			errx(1, "exhausted memory.");
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->lower = time1 + 1;
		snprintf(tmbuf, sizeof(tmbuf), "%s %s", yyvsp[-1].string, yyvsp[0].string);
		strptime(tmbuf, "%Y-%m-%d %H:%M:%S", tm);
		time1 = mktime(tm);
		dsp->upper = time1 - 1;
	}
break;
#line 639 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
